function varargout = Filter_Data(varargin)
% FILTER_DATA M-file for Filter_Data.fig
%      FILTER_DATA, by itself, creates a new FILTER_DATA or raises the existing
%      singleton*.
%
%      H = FILTER_DATA returns the handle to a new FILTER_DATA or the handle to
%      the existing singleton*.
%
%      FILTER_DATA('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in FILTER_DATA.M with the given input arguments.
%
%      FILTER_DATA('Property','Value',...) creates a new FILTER_DATA or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Filter_Data_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Filter_Data_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Filter_Data

% Last Modified by GUIDE v2.5 05-Mar-2008 12:06:45

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Filter_Data_OpeningFcn, ...
                   'gui_OutputFcn',  @Filter_Data_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Filter_Data is made visible.
function Filter_Data_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Filter_Data (see VARARGIN)

% Choose default command line output for Filter_Data
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes Filter_Data wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = Filter_Data_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in back.
function back_Callback(hObject, eventdata, handles)
% hObject    handle to back (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

close(Filter_Data);
kk=Utilities;

% --- Executes on button press in about.
function about_Callback(hObject, eventdata, handles)
% hObject    handle to about (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
msg0={
'----------------------------------------------------------------------';
      '   BATS - Bayesian Analysis for Time Series';
'----------------------------------------------------------------------';
' ';
' ';
'BATS has been written by C.Angelini, L. Cutillo, D.De Canditiis, M. Mutarelli and M. Pensky, 2007-2008.';
'Copyright:  I.A.C. "M. Picone" CNR (ITALY), 2007-2008.';
' ';
'MATLAB is a registered trademark of The MathWorks, Inc.';  
'Java is a trademark of Sun Microsystems, Inc.';
' ';
'Permission to use, copy, modify, and distribute the software BATS for any ';
'purpose without fee is hereby granted, provided that this entire notice is';
'included in all copies of any software which is or includes a copy or'
'modification of this software and in all copies of the supporting';
'documentation for such software.';
' ';
'THIS SOFTWARE IS BEING PROVIDED "AS IS", WITHOUT ANY EXPRESS OR IMPLIED';
'WARRANTY. IN PARTICULAR, THE AUTHORS AND THE MATHWORKS INC DO NOT MAKE ANY ';
'REPRESENTATION OR WARRANTY OF ANY KIND CONCERNING THE MERCHANTABILITY OF ';
'THIS SOFTWARE OR ITS FITNESS FOR ANY PARTICULAR PURPOSE.';
' ';
'The MCR (MATLAB Component Runtime) Libraries are distributed under a ';
'Deployment Agreement for the sole purpose of running BATS, they are';
'provided with the MCR Library License whose terms must be accepted prior';
'to install and use BATS in its compiled form.';
' ';
'When performing analysis with BATS, please cite:';
'C. Angelini, D. De Canditiis, M. Mutarelli, M. Pensky. A Bayesian Approach ';
'to Estimation and Testing in Time-course Microarray Experiments;';
'Statistical Applications in Genetics and Molecular Biology:';
'vol 6 : Iss. 1, Article 24, (2007).'};


msg1={'Written by C. Angelini, L. Cutillo, D. De Canditiis, M. Mutarelli and M. Pensky, 2008.';
    ' ';
 'For any comment please contact us at the followings e-mail address:';
 ' ';
 'bats@na.iac.cnr.it,';
 ' ';
 'For further information visit us at www.na.iac.cnr.it/bats .'
  ' '; ' '; 
 'Copyright:  I.A.C. "M. Picone" CNR (ITALY), 2008.';
 ' ';
 '------------------------------------------------------------------------- ';
 'Permission to use, copy, modify, and distribute the software for any purpose without fee is hereby granted, provided that this entire notice is included in all copies of any software which is or includes a copy or modification of this software and in all copies of the supporting documentation for such software.';
 '  ';
 '  ';
'This software is being provided "as it is", without any express or implied warranty.  In particular, the authors do not make any representation or warranty of any kind concerning the merchantability of this software or its fitness for any particular purpose.';
' ';
'-------------------------------------------------------------------------- ';};
    
msgbox(msg0,'Information about BATS Software');


% --- Executes on button press in help.
function help_Callback(hObject, eventdata, handles)
% hObject    handle to help (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% This utility Routine filters out from the input file all genes with a
% number of missing obresvation larger than the specified threshold. 

%input parameters 
% file_name_input: string denoting the .xls file containing the results of
%                  the experiments in the BATS specified format
% threshold: positive integer, maximum number of missing values accepted for each gene

%output
%file_name_output is a .xls file (the name is obtained adding the string 'filter' to the input_file_name) where the genes containing more than threshold NaNs are removed 
%                  the output file is already in the BATS input format


msg2={'This utility filters out from the input file all genes with a number';  
    ' ';
    'of missing obresvations larger than a user specified threshold (in the';
    ' ';
    'second panel of the filter data window).';
    ' ';
    'The output file is in the BATS input format and its name is formed by';
    ' ';
    'adding the string "filter" to the input file name.'
    };
%                 
f=msgbox(msg2,'Filter Data Utility Description','Help');

% --- Executes on button press in filterdata.
function filterdata_Callback(hObject, eventdata, handles)
% hObject    handle to filterdata (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
try
    hhh=waitbar(0,'Please wait...');
    thresh=round(str2double(get(handles.threshold,'String')));
    file_name=get(handles.dataset,'String');
    isp=find(file_name==' ');
    file_name(isp)=[];
    fid=fopen(file_name);
    if (isempty(fid) || fid==-1 || isempty(file_name) )
        h=msgbox({'Please insert a correct file name to filter!'},'Error');
        uiwait(h);
        close all
        H=Filter_Data;
        return
    elseif thresh<0 || isempty(thresh) || isnan(thresh)
        fclose(fid);
        h=msgbox({'Please insert a correct threshold number!'},'Error');
        uiwait(h);
        close all
        H=Filter_Data;
        return
    else
        fclose(fid);
        waitbar(1/2);
        file_name_out=filterdatanan(file_name,thresh);    
        waitbar(1);
    end
    close(hhh);
    msg={'The Data were filtered! Please check your output file:';file_name_out};
    jjj=msgbox(msg,'Filtering ended');
    uiwait(jjj);
    close all
    eval('BATS');
    
catch
    
    if ~isempty(lasterr)
%         fprintf('caso lasterr pieno')
      jjj=msgbox(lasterr);   
       uiwait(jjj);
       close all
       eval('BATS');
    end
   
end
% --- Executes during object creation, after setting all properties.
function axes1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to axes1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: place code in OpeningFcn to populate axes1

cla;
[A,map,alpha]=imread('Bats.GIF');
        colormap(map);
        image(A);
        axis off

function dataset_Callback(hObject, eventdata, handles)
% hObject    handle to dataset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of dataset as text
%        str2double(get(hObject,'String')) returns contents of dataset as a double


% --- Executes during object creation, after setting all properties.
function dataset_CreateFcn(hObject, eventdata, handles)
% hObject    handle to dataset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
%a=ls('MyData\*.xls');

aa=fullfile('Examples','*');
a=dir(aa);

if ~isempty(a)&&length(a)>2
    file_name=a(3).name;
    set(hObject,'String',fullfile('Examples',file_name))
else
    set(hObject,'String','<empty>')
end


% --- Executes on button press in load.
function load_Callback(hObject, eventdata, handles)
% hObject    handle to load (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if ispc
    [filename, pathn, filterindex]= uigetfile( ...
        { '*.xls','xls-files (*.xls)';'*.txt','txt-files (*.txt)'},...
        'Select a Data File to filter out', ...
        'MultiSelect', 'off');
else
    [filename, pathn, filterindex]= uigetfile( ...
        { '*.xls','xls-files (*.xls)';'*.txt','txt-files (*.txt)'},...
        'Select a Data File to filter out', ...
        'MultiSelect', 'off');
%     [filename, pathn, filterindex] = uigetfile( ...
%         { '*.txt','txt-files (*.txt)'},...
%         'Select a Data File to filter out', ...
%         'MultiSelect', 'off');
end




%[filename, pathn, filterindex] = uigetfile('*.xls;*.txt', 'Pick an xls data file to filter out');
if isequal(filename,0) || isequal(pathn,0)
       disp('User pressed cancel')
else
       disp(['User selected ', fullfile(pathn, filename)])
       file_matrix=[pathn filename];
       set(handles.dataset,'String',file_matrix);

end
 
function threshold_Callback(hObject, eventdata, handles)
% hObject    handle to threshold (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of threshold as text
%        str2double(get(hObject,'String')) returns contents of threshold as a double


% --- Executes during object creation, after setting all properties.
function threshold_CreateFcn(hObject, eventdata, handles)
% hObject    handle to threshold (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




% --- Executes during object creation, after setting all properties.
function uipanel4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to uipanel4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


