function beta = beta_laplace(x,a)

% usage: beta = beta_laplace(x,a);
% PURPOSE : The function beta for the Laplace prior with parameter a
%
if nargin==1, a=0.5; end;
x = abs(x);
a = min(a, 35);
xpa = x + a;
xma = x - a;
rat1 = ones(size(xpa));
rat2 = ones(size(xma));
rat1(abs(xpa) > eps) = 1./xpa(abs(xpa) > eps);
rat2(abs(xma) > eps) = Inf;
rat1(xpa < 35) = pnorm( - xpa(xpa < 35))./dnorm(xpa(xpa < 35));
rat2(xma < 35) = pnorm(xma(xma < 35))./dnorm(xma(xma < 35));
beta = (a/2) .* (rat1 + rat2) - 1;


% THIS ROUTINE IS PART OF THE MATLAB VERSION OF EBAYESTHRESH (from ANTONIADIS et al. 2005)