function databoxplot(file_name_input)
warning off
% This utility Routine allow to display the data box plots for each time
% point.


%input parameter
% file_name_input: string denoting the .xls file containing the results of
%                  the experiments in the BATS specified format


% 
% id=strfind(file_name_input,'.xls');
% id=id(1);
% 
% file_name=file_name_input;
% file_name(id:end)=[];
% file_name_output=[file_name '_filter.xls'];


if strcmp(file_name_input(end-3:end),'.xls')
[dati,testo]=xlsread(file_name_input);
elseif strcmp(file_name_input(end-3:end),'.txt')
A=importdata(file_name_input);
dati=A.data;
testo=A.textdata;
end

[n,m]=size(dati);
for i=1:m
    lll(i)={num2str(dati(1,i))};
end


boxplot(dati(2:end,:),'labels',lll)
%boxplot(dati(2:end,:))
tt=sprintf('experiment: %s',file_name_input');
hold on
% title(['experiment: ' file_name_input])
title(tt)

xlabel('Time points')
ylabel('log2 expression ratio')
hold off


ng=length(testo);

fprintf('File name input %s \n',file_name_input);
fprintf('Total number of genes in the original file %i in %i experiments \n',n-1,m);

Gmiss=sum(isnan(dati(2:end,:)),2);
Amiss=sum(isnan(dati(2:end,:)),1);

fprintf(' \n');
fprintf('Number missing spots %i within  total of %i spots \n',sum(Amiss),(n-1)*m);
maxmiss=max(Gmiss);
fprintf('Maximum number of missing spots %i per gene \n',maxmiss);

fprintf('Number of genes without missing values %i, \n',sum(Gmiss==0)); 
for imiss=1:maxmiss
 fprintf('Number of genes with %i missing values %i,\n',imiss,sum(Gmiss==imiss));   
end
fprintf(' No genes with more than %i missings \n',maxmiss);
 fprintf(' \n'); 
for i=1:m
 fprintf('Array %i contains %i missing spots \n',i,Amiss(i));
end

fprintf(' \n'); 
max_val=max(max(dati(2:end,:))); 
min_val=min(min(dati(2:end,:)));

fprintf('Maximum observed data %3.4f ; Minimum observed data %3.4f \n',max_val,min_val);

%fprintf('Results saved in  %s \n',file_name_output);



% RangeG=sprintf('A1:A%d',ng);
% xlswrite(file_name_output,testo,1,RangeG);
% xlswrite(file_name_output,dati,1,'B1')


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Written by C.Angelini, L. Cutillo, D.De Canditiis, M. Mutarelli and M. Pensky, 2006. 
% Comments? e-mail c.angelini@iac.cnr.it, l.cutillo@na.iac.cnr.it, d.decanditiis@iac.cnr.it
% Copyright:  I.A.C. "M. Picone" CNR (ITALY), 2007.  
%
% Permission to use, copy, modify, and distribute the 
% software for any purpose without fee is hereby granted, provided 
% that this entire notice is included in all copies of any software 
% which is or includes a copy or modification of this software and in 
% all copies of the supporting documentation for such software.
% 
% This software is being provided "as is", without any express or 
% implied warranty.  In particular, the authors do not make any
% representation or warranty of any kind concerning the merchantability
% of this software or its fitness for any particular purpose.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
