function ww = wfromt(tt, prior, a)

% usage: ww = wfromt(tt, prior, a);
% PURPOSE: given the vector of median thresholds tt, find the weight w
%	   that has posterior median threshold tt.

if nargin ==1, % default values
   priors = 'laplace';
   a = 0.5;
end;
 
pr = prior(1);
if pr == 'l', 
   wi = (a * pnorm(tt - a))./dnorm(tt - a) - beta_laplace(tt, a); 
end;
if (pr == 'c'), 
   dnz = dnorm(tt);
   wi = 1 + (pnorm(tt) - tt .* dnz - 1/2)./(sqrt(pi/2) * dnz .* tt.^2);
   wi(~isfinite(wi))= 1;
end;
ww = 1./wi;


  % THIS ROUTINE IS PART OF THE MATLAB VERSION OF EBAYESTHRESH (from ANTONIADIS et al. 2005)