function w = wfromx(x, prior, a)

% usage: w = wfromx(x, prior, a);
% PURPOSE: 
%   given the vector of data x and the function betaf
%   which finds beta(x), find the value of w that zeroes S(w) in the
%   range 
%
%   additional arguments to betaf can be passed through ...
%
%   works by successive bisection, carrying out nits harmonic bisections
%   of the original interval between wlo and 1.  
%  
%
x=x(:);

if nargin == 1   % user-supplied options
	prior='laplace';
	a = 0.5;
end

if  nargin == 2,
	a = 0.5;
end
  
	pr =prior(1);
	tuniv = sqrt(2 * log(length(x)));
	wlo = wfromt(tuniv, prior, a);
	if (pr == 'l'),
		beta = beta_laplace(x, a);
	end;
	if (pr == 'c') ,
		beta = beta_cauchy(x);
	end;
	whi = 1;
	beta = min(beta, 1e20); 
	shi = sum(beta./(1 + beta));
	if (shi >= 0),
	    w=1;
		return;
	end;	
	slo = sum(beta./(1 + wlo * beta));
	if (slo <= 0),
	  w=wlo;
	  return;
	end;  
	
	for j=1:30,
		wmid = sqrt(wlo * whi);
		smid =sum(beta./(1 + wmid * beta));
		if (smid == 0),
			 w = wmid;
			 return;
		end;	 
		if (smid > 0),
			wlo = wmid;
		else whi = wmid;
		end;
	end;
	w = sqrt(wlo * whi);
    
   % THIS ROUTINE IS PART OF THE MATLAB VERSION OF EBAYESTHRESH (from ANTONIADIS et al. 2005)
